首页 > 代码库 > 377. Combination Sum IV
377. Combination Sum IV
https://leetcode.com/problems/combination-sum-iv/#/description
Given an integer array with all positive numbers and no duplicates, find the number of possible combinations that add up to a positive integer target.
Example:
nums = [1, 2, 3] target = 4 The possible combination ways are: (1, 1, 1, 1) (1, 1, 2) (1, 2, 1) (1, 3) (2, 1, 1) (2, 2) (3, 1) Note that different sequences are counted as different combinations. Therefore the output is 7.
Follow up:
What if negative numbers are allowed in the given array?
How does it change the problem?
What limitation we need to add to the question to allow negative numbers?
Sol:
DP.
class Solution(object): def combinationSum4(self, nums, target): """ :type nums: List[int] :type target: int :rtype: int """ # DP nums.sort() dp = [0] * (target + 1) dp[0] = 1 # if num == target # before we figure out the number of ways that add up to target, we figure out the number of ways that add up to target - 1, target - 2, ..., 1. for currSum in range(1, target + 1): for num in nums: if num > currSum: break dp[currSum] += dp[currSum - num] return dp[target]
377. Combination Sum IV
声明:以上内容来自用户投稿及互联网公开渠道收集整理发布,本网站不拥有所有权,未作人工编辑处理,也不承担相关法律责任,若内容有误或涉及侵权可进行投诉: 投诉/举报 工作人员会在5个工作日内联系你,一经查实,本站将立刻删除涉嫌侵权内容。